/* (C) 2001-2002 Andrew J. Kroll */
/* see file README for license details */

/* 
current network utilities.

DNS lookups

More to come dependent upon need.

IMPORTANT!
NETWORK MUST BE ALREADY UP AND INITIALIZED!
"MAKEMEBLEED" is needed on slow systems.
*/



#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "tcpvars.h"
#include "compat.h"
#include "netutil.h"
#include "in.h"
#include "netinet.h"
#include "socket.h"
#include "timers.h"
#include "compat.h"

#define DEBUGDNS 0
#define DEBUGSOCK 0
/* set this to non zero for tcp dns */

#define TCP 0


#if DEBUGDNS
void showrec(bptr)
char *bptr;
{
	printf("type %2.2x%2.2x ", (short)(bptr[0] & 0xff),(short)(bptr[1] & 0xff));
	printf("class %2.2x%2.2x ", (short)(bptr[2] & 0xff),(short)(bptr[3] & 0xff));
	printf("ttl %2.2x%2.2x", (short)(bptr[4] & 0xff),(short)(bptr[5] & 0xff));
	printf("%2.2x%2.2x ", (short)(bptr[6] & 0xff),(short)(bptr[7] & 0xff));
	printf("len %2.2x%2.2x ", (short)(bptr[8] & 0xff),(short)(bptr[9] & 0xff));
}
#endif

int parse_results(hostinfo, result, query, len, p, q, r, s, care, k) 
char *hostinfo;
struct u_nameip *result;
unsigned char *query;
int len;
int p;
int q;
int r;
int s;
int care;
int k;
{

	register char *data;
	register char *bptr;
	register char *cptr;
	register char *flag;
	unsigned short j;
	unsigned short l;
	unsigned short z;
	unsigned short i;
	
	data = bptr = flag = NULL;
	z = 0;
	
	if(!k) {
		i = len;
#if DEBUGDNS
		bptr = (char *)query;
		z = i;
		printf("got %i bytes: ", i);
		while (z) {
			printf("%2.2x ", bptr[0] & 0xff);
			z--;
			bptr++;
		}
		printf("\n");
	
#endif
		/* parse results */
		if(((query[3] & 0x0f)) || ((!query[6]) && (!query[7]))) {
			k++; /* some kind of error, we don't care what error though */
#if DEBUGDNS
			printf("Not found on DNS\n");
#endif
		} else {
			bptr = (char *)query;
			/* skip past header section */
			bptr += 12;
			j = 12; 
			while ((bptr[0]) && (j < i)) {
				z = 1 + (short)(bptr[0] & 0xff);
				bptr += z;
				j += z;
			}
			bptr++;
			j++;
			/* we're now at the Qtype/Qclass section */
			cptr = bptr;
			flag = cptr;
			flag++;
			bptr += 4; /* now at the first record */
			j += 4;
			z = 0;
			MAKEMEBLEED
			/* find first match */
			while(!z && j < i) {
#if DEBUGDNS
				printf("Record @%i(%2.2x) ", j, j);
#endif
				data = bptr;
				while ((bptr[0])) {
					if((bptr[0] & 0xc0) == 0xc0) {
						bptr++;
						j++;
						break;
					} else {
						l = 1 + (short)(bptr[0] & 0xff);
						bptr += l;
						j += l;
					}
				}
				bptr++;
				j++;
#if DEBUGDNS
				showrec(bptr);
#endif
				if((cptr[0] == bptr[0]) && (cptr[1] == bptr[1]) && (cptr[2] == bptr[2]) && (cptr[3] == bptr[3])) {
#if DEBUGDNS
					printf("Matched\n");
#endif
					z++; /* we have a match */
				} else {
					/* no match, point to the next record */
					l = (((unsigned short)(bptr[8] & 0xff) * 256) + (unsigned short)(bptr[9] & 0xff)) + 10;
					bptr += (unsigned short)l;
					j += (unsigned short)l;
#if DEBUGDNS
					printf("add 10+%i, next\n", l - 10);
#endif
				}
			}
			MAKEMEBLEED
			if(!z) {
#if DEBUGDNS
				printf("No matches\n");
#endif
				k++;
			}
		}
	}

	/* realloc and copy data from matching record to buffers, providing a record was found */
	if(!k) {
		/* supposedly the IP sits at bptr, as calculated above, or it may infact be host info */
		l = (((short)(bptr[8] & 0xff) * 256) + (short)(bptr[9] & 0xff));
		bptr += 10;
		if((flag[0] & 0xff) != 0x0c) {
			/* copy length and data back */
			result->hostip = MALLOC(l);
			if(!(result->hostip)) { 
				k++;
#if DEBUGDNS
				printf("IP data block malloc failed ");
#endif
			} else {
				cptr = result->hostip;
				memmove(cptr, bptr, l);
			}
		} else {
			data = bptr;
			result->hostip = MALLOC(4);
			if(!(result->hostip)) {
				k++;
#if DEBUGDNS
				printf("MIP data block malloc failed ");
#endif
			} else {
				bptr = result->hostip;
				bptr[0] = p & 0xff;
				bptr[1] = q & 0xff;
				bptr[2] = r & 0xff;
				bptr[3] = s & 0xff;
			}
		}
	}
	MAKEMEBLEED
	/* decode the host data record */
	if(!k) {
		bptr = data;
		l = 0;
		while(((bptr[0])) && (!k)) {
			if((bptr[0] & 0xc0) == 0xc0) {
				/* pointer */
				j = ((short)(bptr[0] & 0x3f) * 256) + (short)(bptr[1] & 0xff);
				bptr = (char *)query;
				bptr += j;
			} else {
				/* data, dot */
				j = (short)(bptr[0] & 0xff);
				bptr++;
				z = l;
				l += j;
				result->hostname = REALLOC(result->hostname,l + 2);
				if(!(result->hostname)) {
#if DEBUGDNS
					printf("\nhostname malloc failed ");
#endif
					k++;
				} else {
					for(; z < l; z++) {
						result->hostname[z] = bptr[0];
						bptr++;
#if DEBUGDNS
						printf("%c",result->hostname[z]);
#endif
					}
#if DEBUGDNS
					printf(".");
#endif
					l++;
					result->hostname[z] = '.';
					result->hostname[z + 1] = 0x00;
				} 
			}
		}
		MAKEMEBLEED
		if(!k) {
			/* remove last dot */
			result->hostname[z] = 0x00;
		}
	}
	if(k) {
#if DEBUGDNS
		printf("Bad....\n");
#endif
		/* if we don't care, and just wanted to parse IP... */
		if ((care == 1) && ((flag[0] & 0xff) == 0x0c)) {
#if DEBUGDNS
			printf("don't care\n");
#endif
			k = 0;
			result->hostname = REALLOC(result->hostname, strlen(hostinfo) + 1);
			result->hostip = REALLOC(result->hostip, 4);
			if((!result->hostname) || (!result->hostip)) {
				k++;
			} else {
				sprintf(result->hostname, "%s", hostinfo);
				bptr = result->hostip;
				bptr[0] = p & 0xff;
				bptr[1] = q & 0xff;
				bptr[2] = r & 0xff;
				bptr[3] = s & 0xff;
			}
		}
	}

	MAKEMEBLEED
#if DEBUGDNS
	printf("\nReturning %i\n",k);
#endif
	return(k);
}

/* 
	Find host. 
	WARNING this routine will NOT do a lookup of a hex number! 
	Remeber to free ram! 
*/
struct u_nameip *findhost(hostinfo, care)
char *hostinfo;
int care;
{
	struct u_nameip *result;
	unsigned char *query;
	char *myhost;

	char *ptr;
	char *data;
	char *bptr;
	char *cptr;
	short i;
	int j;
	int k;
	int l;
	int z;
	int p;
	int q;
	int r;
	int s;
	unsigned char b;
	char flag;
#if TCP	
	result = NULL;
#else
	int noreply;
	struct sockaddr_in srv_addy; /* bind */
	struct sockaddr_in to; /* sendto */
	struct sockaddr_in from; /* recvfrom */
	unsigned char *rcd;
	unsigned long now;

	rcd = NULL;
	result = NULL;
	rcd = MALLOC(514);
	if(!rcd) {
		goto bailz;
	}

	srv_addy.sin_family = AF_INET;
	srv_addy.sin_port = 8192;  /* this should be free port # */
	bptr = (char *)(&srv_addy.sin_addr);
	*bptr = 0;
	bptr++;
	*bptr = 0;
	bptr++;
	*bptr = 0;
	bptr++;
	*bptr = 0;


	to.sin_family = AF_INET;
	to.sin_port = 53;
	query = (unsigned char *)(&to.sin_addr);
	*query = mydns[0];
	query++;
	*query = mydns[1];
	query++;
	*query = mydns[2];
	query++;
	*query = mydns[3];
	
#endif
	/* init common vars */
	query = NULL;
	myhost = NULL;
	j = k = l = p = q = r = s = 0;
	b = 0x00;
	flag = 0x01;
	z = sizeof(struct u_nameip);


	/* check user data */
	if ((!hostinfo) || (!hostinfo[0])) {
		goto bailx;
	}

	/* claim ram regions */
	result = MALLOC(z);
	if(!result) {
		k = -1;
		goto bailx;
	} else {
		memset(result, 0, z);
		result->hostname = result->hostip = NULL;
	}


	result->hostname = MALLOC(strlen(hostinfo) + 64);
	if(!result->hostname) {
		k = -1;
		goto bailr;
	} else {
		memset(result->hostname, 0, strlen(hostinfo) + 64);
	}

	myhost = MALLOC(strlen(hostinfo) + 64);
	if(!myhost) {
		k = -1;
		goto bailr;
	} else {
		sprintf(myhost, "%s", hostinfo);
	}

	query = MALLOC(514);
	if(!query) {
		k = -1;
		goto bailm;
	}

	/* memory is ready, parse */

parse:
	MAKEMEBLEED

	memset(query, 0, 514);
	cptr = (char *)query;
	ptr = myhost;
	data = result->hostname;
	bptr = data;
	data++;
	/* test for alphas, count dots, build string */
	while(ptr[0]) {
		data[0] = cptr[0] = ptr[0];
		b++;
		if(isalpha(ptr[0])) j++;
		if(ptr[0] == '.') {
			b--;
			l++;
			bptr[0] = b;
			bptr = data;
			b = cptr[0] = 0x00;
		}
		ptr++;
		data++;
		cptr++;
	}
	MAKEMEBLEED
	bptr[0] = b;

	/* form query */
	if((!j) && (l == 3)) {
		/* number to name, flip numbers, tack on .in-addr.arpa, reparse */
		/* they are already seperated in the above routine */
		cptr = (char *)query + strlen((char *)query) + 1;
		bptr = cptr + strlen(cptr) + 1;
		data = bptr + strlen(bptr) + 1;
		sprintf(myhost, "%s.%s.%s.%s.in-addr.arpa", data, bptr, cptr, (char *)query);
		p = atoi((char*)query);
		q = atoi(cptr);
		r = atoi(bptr);
		s = atoi(data);
		b = 0x00;
		l = 0;
		flag = 0x0c;
		goto parse;
	}
	bptr = (char *)query;
	bptr = bptr + 4; /* our ID is from whatever was in the queue */
	memset(bptr, 0, 20);
	bptr[0] = bptr[3] = 0x01;
	bptr = bptr + 10;
	i = 12;
	data = result->hostname;
	/* copy pre-parsed info */
	while(data[0]) {
		bptr[0] = data[0];
		bptr++;
		data++;
		i++;
	}
	/* skip ahead, terminate message */
	bptr[2] = flag;
	bptr[4] = 0x01;
	i = i + 5; /* this is the full message length now */
	/* note, these 2 bytes are not used for udp */
	query[0] = (i / 256) & 0xff;
	query[1] = i & 0xff;
	i = i + 2; /* write length */
	/* send query */
#if TCP
	l = socket(AF_INET, SOCK_STREAM, IPPROTO_IP);
#else
	l = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
#if DEBUGSOCK
	printf("Socket status %i", l);
#endif
#endif
	if(l > -1) {
#if TCP
		j = sockconnect(l, 53, (unsigned char *)&mydns[0]);
#else
		/* bind the port. Screwy way to do this, but works. */
#if DEBUGSOCK
		printf("Binding...\n"); fflush(stdout);
#endif
		j = bind(l, (struct sockaddr_in *)&srv_addy, sizeof(srv_addy));
#if DEBUGSOCK
		printf("Bind status %i\n", j); fflush(stdout);
#endif		
#endif
		if(j > -1) {
			bptr = (char *)query;
#if TCP
			while(i > 0) {
				l = sockwrite(j, bptr, i);
				if( l < 0) {
					i = 0;
					k++;
				} else {
					i = i - l;
					bptr += l;
				}
			}
			if(!k) {
				/* read back answer */
				bptr = (char *)query;
				/* 2 bytes + rest of message */
				l = 0;
				while(!l) {
					l = sockread(j, bptr, 1);
				}
				if(l < 1) {
					k++;
				} else {
					l = 0;
					bptr++;
					while(!l) {
						l = sockread(j, bptr, 1);
					}
					if(l < 1) {
						k++;
					} else {
						i = ((short)(query[0] & 0xff) * 256) + (short)(query[1] & 0xff);
						z = i;
						FREE(query);
						query = MALLOC(z);
						if(!query) {
							k++;
							goto bailm;
						}
						memset(query, 0, z);
						bptr = (char *)query;
						while(z > 0) {
							l = sockread(j, bptr, z);
							if(l < 0) {
								k++;
								z = 0;
							} else {
								z = z - l;
								bptr += l;
							}
						}
					}
				}
			}
			sockclose(j);
#else
			j = l;
			/* strip off the first 2 bytes, unneeded for udp */
			bptr++;
			bptr++;
			i--;
			i--;
			/* unfortunatly udp needs US to track it... ugh, what crap! */
			/* i = data send len, bptr = the buffer of data */
#if DEBUGSOCK
			printf("Query length = %2.2x\n", i);
#endif
/* udpcrap: this will be used later on? */
			noreply = 1;
			while(noreply) {
#if DEBUGSOCK
				printf("Sending..."); fflush(stdout);
#endif
				k = sendto(j, bptr, i, 0, (struct sockaddr *)&to, sizeof(to));
#if DEBUGSOCK
				printf("Sendto status = %i", k); fflush(stdout);
#endif
				if(!k) {
					now = CHK_TIME1 + (loopcali * RETRYTIME);
					/* packet was sent, we need to wait a bit for a reply */
					do {
						k = sockdepth(j, 0);
						if(now < CHK_TIME1) break;
					} while(k < 1);
					if(k) noreply = 29; /* exit out */
				}
				noreply++;
				if(noreply == 30) noreply = 0; /* exit out */
			}
			
			if(k) {
				l = k;
				k = 0; /* status good */
				/* l holds the message length waiting for us + header len */
#if DEBUGSOCK
				printf("We have something!\n"); fflush(stdout);
#endif
				l = recvfrom(j,  rcd, 514, 0, (struct sockaddr *)&from, sizeof(from));
				/* bad part II, have to verify it is from the dns server we called! */
				ptr = (char *)(&from.sin_port);
#if DEBUGSOCK
				printf("Package from %i.%i.%i.%i %i %i bytes\n", (unsigned char)ptr[2], (unsigned char)ptr[3], (unsigned char)ptr[4], (unsigned char)ptr[5], (unsigned short)((unsigned char)(ptr[0]) + (unsigned short)(256 * (unsigned char)ptr[1])), l); 
#endif
				/* here we have to stuff the needed bytes 
				where the parser expects them to be, so the offset is usable */
				/* pretend all is well */
				i = l;
				FREE(query);
				query = rcd;
				rcd = NULL;
			}
#endif
		} else {
			k++;
		}
	} else {
		k++;
	}


	MAKEMEBLEED
	if(k < 1) {
#if DEBUGSOCK
		printf("parsing results\n"); fflush(stdout);
#endif
		k = 0;
		k = parse_results(hostinfo, result, query, i, p, q, r, s, care, k);
	}
	FREE(query);
bailm:
	FREE(myhost);
bailr:
	if(k) {
		/* error */
		if(result) {
			if(result->hostname) FREE(result->hostname);
			if(result->hostip) FREE(result->hostip);
			FREE(result);
		}
		result = NULL;
	}
bailx:
#if TCP
	/* nothing */
#else
	if(rcd) FREE(rcd);
#endif
bailz:
	return(result);
}


/* tell link parser who we are and where we belong

0000 libutil.lib netutil.obj xxLIBRARYxx

*/

